<?Php
/**
* @version $Id: afschrijfboek.php,v 0.7 2006/08/17 Exp $
* @package Joomla
* @subpackage Afschrijfboek
* @copyright (C) 2006 Tonci Galic, Sjoerd Hardeman, Laszlo van den Hoek, cia@skoll.nl
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* Joomla is Free Software
*/

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed. afschrijfboek.php' );
// require the html view class
require_once( $mainframe->getPath( 'front_html' ));
require_once( $mainframe->getCfg( 'absolute_path')."/includes/pageNavigation.php");
if ($Itemid == '' ) $Itemid = intval(mosGetParam ( $_POST, 'Itemid', '1' ));

$mainframe->setPageTitle("Afschrijfboek - test");

$component_root = $mainframe->getCfg( 'absolute_path' )."/components/com_afschrijfboek";
$task = mosGetParam($_REQUEST,'taak');

//Settings:
$boekmax = 120*60; // 1,5 uur ivm HIC, normaal 2 uur maximaal reserveren
$maxvooruit=7;  // Maximaal vooruit te boeken
$time_offset=0; // Wintertijd of zomertijd?
$now = time();
$email_schade = "mail@mail.ma";

$types = array (
	array('boot' => '1', 'query' => 'AND bn_seats = 1 AND (bspeciaal = 0 OR bspeciaal is NULL)'),
	array('boot' => '2', 'query' => 'AND bn_seats = 2 AND (bspeciaal = 0 OR bspeciaal is NULL)'),
	array('boot' => '4', 'query' => 'AND bn_seats = 4 AND (bspeciaal = 0 OR bspeciaal is NULL)'),
	array('boot' => '8', 'query' => 'AND bn_seats = 8 AND (bspeciaal = 0 OR bspeciaal is NULL)'),
	array('boot' => 'overig', 'query' => 'AND bspeciaal = 1'),
	array('boot' => 'alle', 'query' => '')
);

$bootbaas1=0;
$afschrijfbaas1=0;

// Moet nog in de database, zodat het ook met de beheeersmodule beheerd kan gaan worden
$bootbaas = array (1 => $bootbaas1); 
$afschrijfbaas = array (1 => $afschrijfbaas1);
$blocklist = array ();

if (in_array($my->id,$blocklist)) {
	ab_HTML :: error($option, 'Je account is geblockt voor het afschrijfboek. Vraag het bestuur of dit weer ongedaan gemaakt kan worden' );
	return;
}

$local="nl_NL.UTF-8";

switch ($task) {
	case 'toon':
		toon_ab($option);
		break;
	case 'boek':
		boek_ab($option);
		break;
	case 'reserveer':
		reserveer_ab($option);
		break;
	case 'freeres':
		freeres_ab($option);
		break;
	case 'checkfreeres':
		checkfreeres($option);
		break;
	case 'forcefreeres':
		forcefreeres($option);
		break;
	case 'toonres':
		toonres_ab($option);
		break;
	case 'dodel':
		dodel_ab($option);
		break;
	case 'wijzig':
		wijzig_ab($option);
		break;
	case 'disclaimer':
		disc_ab($option);
		break;
	case 'boot':
		boot($option);
		break;
	case 'bootedit':
		bootedit($option);
		break;
	case 'help':
		help_ab($option);
		break;
	case 'admin':
		admin($option);
		break;
	case 'schadeboek':
		schadeboek($option);
		break;
	case 'lookback':
		toon_ab($option,true);
		break;
	default:
		toon_ab($option);
		break;
}


function toon_ab($option,$lookback=false) {
	global $mainframe,$local;
	global $database,$maxvooruit,$afschrijfbaas;
	global $types,$time_offset;
	
	if (!in_array($my->id,$afschrijfbaas)) $lookback=false;
	
	// Als datum of boottype opgegeven, lees dan uit.
	$datum=mktime(0,0,0);
	if ($lookback && mosGetParam($_POST,'datum')) {
		$arr_datum = explode("-",mosGetParam($_POST,'datum'));
		$datum = mktime(0,0,0,$arr_datum[1],$arr_datum[0],$arr_datum[2]);
	}
	else 
		if (mosGetParam($_REQUEST,'datum')) $datum = intval(mosGetParam($_REQUEST,'datum'));
		
	if (!in_array($my->id,$afschrijfbaas) && $datum < mktime(0,0,0)) $datum = mktime(0,0,0);
	if (!in_array($my->id,$afschrijfbaas) && $datum > (mktime(0,0,0) + 86400 * $maxvooruit)) $datum > (mktime(0,0,0) + 86400 * $maxvooruit);
		
	$type = intval(mosGetParam($_REQUEST,'type','2'));
	// Lees boten uit
	$bquery = "SELECT ab_boats.*,ab_schade.kapot,ab_stippen.code AS stip FROM ab_boats LEFT JOIN ab_schade ON ab_boats.bid=ab_schade.bid LEFT JOIN ab_stippen ON ab_boats.bstip=ab_stippen.stipid WHERE bused_as = 'C' and bfree_to_use = '1' ".$types[$type]['query']." ORDER BY btype,bn_seats,bname";
	$database->setQuery($bquery);
	$boots = $database->loadObjectList();
	// Als het goed is $boots een array van bootnummers (bids) en bootnamen
	// Lees reserveringen per boot uit
	foreach( $boots as $boot ) {
		$tquery = "SELECT uid, UNIX_TIMESTAMP(start) as start, UNIX_TIMESTAMP(finish) as finish, users.name FROM ab_reservations r LEFT JOIN users ON (uid = users.id) WHERE bid = '$boot->bid' HAVING start <= $datum+86400+($time_offset*3600) AND finish > $datum+($time_offset*3600)";
		$database->setQuery($tquery);
		$tijden[$boot->bid] = $database->loadObjectList(); // Kijken of dit werkt. Goed nadenken over format MySQL-arrays
	}
	// $tijden moet nu in prinipe alle data van de tabel bevatten. Dit moet dan naar de html->output frontend.
	// Pathway instellen
	setlocale(LC_TIME, $local);
	$mainframe->appendPathWay( "Overzicht - ".strftime("%A %d %B %G",$datum));

	ab_HTML :: teken_tabel($option,$tijden,$datum,$boots,$type,$lookback);
}

function boek_ab($option) {
	global $mainframe,$my,$afschrijfbaas,$maxvooruit;
	global $database;
	global $boekmax;
	global $time_offset;
	global $now;
	
	//Inladen boekingsgegevens
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	$start = intval(mosGetParam($_REQUEST,'start'));
	
	if (mosGetparam($_REQUEST,'from') == "lookback") $from = "lookback";
	
	if (!in_array($my->id,$afschrijfbaas)) {
		if (start > $maxvooruit*86400)
			ab_HTML :: error ("Ongeldige datum opgegeven");
	}
	if ($start < $now) $start = $now;
	$finish = $start + $boekmax; // Kan wasch. niet, nadenken over betere vorm.
	$bid = intval(mosGetParam($_REQUEST,'boot'));
	// $einds moet verzameliing mogelijke eindtijden worden, tot maximaal $BOEKMAX vooruit. Eventueel later typeonderscheid toevoegen.
	$query = "SELECT uid, UNIX_TIMESTAMP(start) as start, UNIX_TIMESTAMP(finish) as finish FROM ab_reservations r WHERE r.bid = $bid HAVING start < $finish-($time_offset*3600) AND finish > $start-($time_offset*3600)";
	$database->setQuery($query);
	$tijds = $database->loadObjectList();

	foreach ($tijds as $tijd)  
	{
		if ($tijd->start+($time_offset*3600) < $start && $tijd->finish+($time_offset*3600) > $start && $tijd->finish+($time_offset*3600) <= $finish) $start=$tijd->finish+($time_offset*3600);
		if ($tijd->start+($time_offset*3600) <= $finish && $tijd->start+($time_offset*3600) > start) $finish=$tijd->start+($time_offset*3600);

	}

	$query = "SELECT bid, bname,bdonker FROM ab_boats WHERE bid='$bid'";
	$database->setQuery($query);
	$database->loadObject($boot);
	
	$mainframe->appendPathWay( "Boeken");
	
	ab_HTML :: reserveer_boot($option,$start,$finish,$boot,$datum,$type,$from);
}

function reserveer_ab($option) {
	global $mainframe,$database,$my,$Itemid,$boekmax,$now;
	
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	if (mosGetparam($_REQUEST,'from') == "lookback") $from = "lookback";

	//Kan in database schrijven, moet deze waarden via een post krijgen!
	$bid = intval(mosGetParam($_REQUEST,'bid',NULL,'POST'));
	$start = intval(mosGetParam($_REQUEST,'start',NULL,'POST'));
	if ($start < $now) {
		ab_HTML :: error ($option,"Fout: starttijd in het verleden");
		exit();
	}
	if (!in_array($my->id,$afschrijfbaas)) {
		if (start > $maxvooruit*86400)
			ab_HTML :: error ("Ongeldige datum opgegeven");
        }
	$finish = intval(mosGetParam($_REQUEST,'finish',NULL,'POST'));
	if($start >= $finish) {
		ab_HTML :: error($option,"Je hebt een starttijd groter dan of gelijk aan de eindtijd opgegeven: $start, $finish!<br />");
		exit();
	}
	if ($finish > $start + $boekmax) {
		ab_HTML :: error ($option,"Afschrijfduur is langer dan toegestaan!");
		exit();
	}
	// Check of afschrijving mogelijk is
	$query = "SELECT uid, UNIX_TIMESTAMP(start) as start, UNIX_TIMESTAMP(finish) as finish FROM ab_reservations r WHERE r.bid = $bid HAVING start < $finish AND finish > $start";

	$database->setQuery($query);
	$reserverings = $database->loadObjectList();
	#Controleer format van query-resultaat
	$overlap = 0;
	foreach ($reserverings as $reservering)  
	{
		if ($reservation['finish'] > $start || $reservation['start'] < $finish) $overlap = 1;
	}
	// ZO nee: schrijf af.
	if (!$overlap) 
	{
		$userid = $my->id;
		$link = "index.php?option=$option&Itemid=$Itemid&taak=$from&datum=$datum&type=$type";
		$query2="INSERT INTO ab_reservations VALUES(NULL,$bid, $userid, NULL, FROM_UNIXTIME($start), FROM_UNIXTIME($finish))";
		$database->setQuery($query2);
		
		if($database->Query() ) $return = "Boot is afgeschreven. <a href=".sefRelToAbs( $link ).">Klik hier</a> om terug te keren naar het afschrijfboek.<BR />\n";
		else $return = "Er is een fout opgetreden.Neem contact op met <a href='mailto:webmaster@skoll.nl'>webmaster@skoll.nl</a><br> Foutmelding: ".$database->getErrorMsg() ;
	} 
	// Anders: geef fout
	else 
	{
		ab_HTML :: error ($option, "Kan boot niet afschrijven; overlappende reservering. Check de begin- en eindtijd.\n");
		exit();
	}
	
	$mainframe->appendPathWay( "Boeken");
	
	ab_HTML :: resultaat($option,$return);
}

function toonres_ab($option) {
	global $database,$boekmax,$mainframe;
	global $time_offset;
	
	//Moet komen uit URL in afschrijfboek. Deze zou al user-gecrontroleerd moeten zijn, zodat alleen de afschrijver van de boot hier kan komen. Voor de zekerheid natuurlijk toch nog even een extra check
	
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	if (mosGetparam($_REQUEST,'from') == "lookback") $from = "lookback";

	// Vraag gegevens te verwijderen afschrijving op
	$start = intval(mosGetParam($_REQUEST,'start'));
	$bid = intval(mosGetParam($_REQUEST,'boot'));
	
	$query = "SELECT id,bid,uid,tid,UNIX_TIMESTAMP(start) as start, UNIX_TIMESTAMP(finish) as finish FROM ab_reservations where bid = $bid AND UNIX_TIMESTAMP(start) = $start";
	$database->setQuery($query);
	$database->loadObject($reservering);
	
	$query = "SELECT bid, bname, bdonker FROM ab_boats WHERE bid='$reservering->bid'";
	$database->setQuery($query);
	$database->loadObject($boot);
	
	$max = ($reservering->start)+$boekmax;
	$query = "SELECT uid, UNIX_TIMESTAMP(start) as start, UNIX_TIMESTAMP(finish) as finish FROM ab_reservations WHERE bid = $bid HAVING start >= $reservering->finish AND start < $max";
	$database->setQuery($query);
	$tijds = $database->loadObjectList();
	
	foreach ($tijds as $tijd)  
	{
		if ($tijd->start < $max) $max = $tijd->start;
	}
	
	if ($max < $reservering->finish) $max = $reservering->finish;
	
	$mainframe->appendPathWay( "$boot->bname");

	ab_HTML :: toon_res($option,$reservering,$boot,$max,$datum,$type,$from);
}

function dodel_ab($option) {
	global $database,$my,$mainframe,$Itemid,$afschrijfbaas;
	$res = intval(mosGetParam($_POST,'resid',NULL));
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	if (mosGetparam($_REQUEST,'from') == "lookback") $from = "lookback";

	// Als hier dan is er ja geklikt. Wederom schrijven in database, dus alles via POST
	if (in_array($my->id,$afschrijfbaas)) {
		$query = "DELETE FROM ab_reservations WHERE id = $res"; // Voor afschrijfbaas geen id-check
	}
	else {
		$query = "DELETE FROM ab_reservations WHERE id = $res AND uid=$my->id" ;// verwijderen op reserveringsnummer, id-check!
	}
	$database->setQuery($query);
	
	if($database->Query() ) {
		$link = "index.php?option=$option&Itemid=$Itemid&datum=$datum&type=$type&taak=$from";
		$return = "De reservering is verwijderd. <a href=".sefRelToAbs( $link ).">Klik hier</a> om terug te keren naar het afschrijfboek.<br />\n";
	}
	else
	{
		ab_HTML :: error ($option, "Er is een fout opgetereden. Neem contact op met <a href='mailto:webmaster@skoll.nl'>webmaster@skoll.nl</a><br> Foutmelding: ".$database->getErrorMsg()) ;
	}
	
	$mainframe->appendPathWay( "Verwijderen");
	
	ab_HTML :: resultaat($option,$return);
}

function wijzig_ab($option) {
	global $database,$my,$mainframe,$Itemid;
	$start = intval(mosGetParam($_POST,'start',NULL));
	$finish = intval(mosGetParam($_POST,'finish',NULL));
	$res = intval(mosGetParam($_POST,'resid',NULL));
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	if (mosGetparam($_REQUEST,'from') == "lookback") $from = "lookback";

	
	if($start >= $finish) {
		ab_HTML :: error($option,"Je hebt een starttijd groter dan of gelijk aan de eindtijd opgegeven: $start, $finish!<br />");
		exit();
	}
	
	$query = "UPDATE ab_reservations SET start=FROM_UNIXTIME($start), finish=FROM_UNIXTIME($finish) WHERE id=$res AND uid=$my->id";
	$database->setQuery($query);

	if($database->Query() ) {
		$link = "index.php?option=$option&Itemid=$Itemid&datum=$datum&type=$type&taak=$from";
		$return = "De reservering is aangepast. <a href=".sefRelToAbs( $link ).">Klik hier</a> om terug te keren naar het afschrijfboek.<br />\n";
	}
	else
	{
		ab_HTML :: error ($option, "Er is een fout opgetereden. Neem contact op met <a href='mailto:webmaster@skoll.nl'>webmaster@skoll.nl</a><br> Foutmelding: ".$database->getErrorMsg()) ;
	}
	
	$mainframe->appendPathWay( "Wijzigen");
	
	ab_HTML :: resultaat($option,$return);
}

function disc_ab($option) {
	global $mainframe;
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	if (mosGetparam($_REQUEST,'from') == "lookback") $from = "lookback";
	ab_HTML :: disclaimer ($option,$datum,$type,$from);
	$mainframe->appendPathWay( "Disclaimer");
}

function help_ab($option) {
	global $mainframe,$hidehelp;
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	if (mosGetparam($_REQUEST,'from') == "lookback") $from = "lookback";
	
	ab_HTML :: help ($option,$datum,$type,$from);
	$mainframe->appendPathWay( "Help");
}

function boot($option) {
	global $database,$my,$mainframe;
	
	if (mosGetParam($_REQUEST,'from') == "schadeboek")
		$taak="schadeboek";
	elseif (mosGetparam($_REQUEST,'from') == "lookback") 
		$taak = "lookback";
	else
		$taak="afschrijfboek";
		
	$datum = intval(mosGetParam($_REQUEST,'datum'));
	$type = intval(mosGetParam($_REQUEST,'type'));

	
	$bid = intval(mosGetParam($_REQUEST,'boot'));
	$query = "SELECT ab_boats.*,ab_schade.kapot,ab_schade.schade,ab_schade.rapport FROM ab_boats LEFT JOIN ab_schade on ab_boats.bid=ab_schade.bid where ab_boats.bid='$bid'";
	$database->setQuery($query);
	$database->loadObject($result);
	$mainframe->appendPathWay( "Informatie $result->bname");
	
	ab_HTML :: boot_show ($option,$taak,$result,$datum,$type);
}

function bootedit($option) {
	global $my,$database,$bootbaas,$mainframe,$Itemid,$email_schade,$now;
	
	if (mosGetParam($_REQUEST,'from') == "schadeboek")
		$taak="schadeboek";
	elseif (mosGetparam($_REQUEST,'from') == "lookback") 
		$taak = "lookback";
	else
		$taak="afschrijfboek";
	
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	
	$edit = false;
	if (in_array($my->id,$bootbaas)) $edit = true;
	$mainframe->appendPathWay( "Schadeboek");
	if ($edit) {
		$kapot = false;
		if (mosGetParam($_POST,'kapot')) $kapot = true;
		$in_schade = mosGetParam($_POST,'schade');
		$bid = intval(mosGetParam($_POST,'bid'));
		
		$schade = $database->getEscaped($in_schade);
		
		if ($kapot) $query = "REPLACE INTO ab_schade VALUES ($bid,NULL,NULL,$kapot,'$schade',NULL)";
		else $query = "DELETE FROM ab_schade WHERE bid=$bid";
		$database->setQuery($query);
	}
	else {
		$uid=intval(mosGetParam($_POST,'uid'));
		$bid=intval(mosGetParam($_POST,'bid'));
		$in_rapport = mosGetParam($_POST,'rapport');
		
		$rapport = $database->getEscaped($in_rapport);
		
		$query = "SELECT * FROM ab_schade WHERE bid='$bid'";
		$database->setQuery($query);
		$database->loadObject($result);
		if ($result->kapot) {
			ab_HTML :: error ($option, "De boot is al uit de vaart. Kan geen nieuwe schade toevoegen");
			break;
		}
		
		$query = "SELECT bid,bname FROM ab_boats where bid='$bid'";
		$database->setQuery($query);
		$database->loadObject($boot);
		
		if ($result->rapport) $rapport = $result->rapport." --- ".$rapport;
		$query = "REPLACE INTO ab_schade VALUES ($bid,NULL,NULL,0,NULL,'$rapport')";
		$database->setQuery($query);
		if($rapport) $mail = true;
	}

	if($database->Query() ) {
		$link = "index.php?option=$option&Itemid=$Itemid&datum=$datum&type=$type&taak=$taak";
		$return = "De verandering is succesvol doorgevoerd. <a href=".sefRelToAbs( $link ).">Klik hier</a> om terug te keren naar het $taak.<br />\n";
		if ($mail) {
			$email_rapport = "Beste $my->name,\n
			\n
			In de definitieve versie van het systeem krijgt de materiaalcommissaris een automaitische mail als je een schademelding doorgeeft. Om in de testfase de materiaalcommissaris niet te overbelasten met driemiljard mailtjes wordt dit mailtje in plaats daarvan nu aan de melder gestuurd. Als je dit mailtje ontvangt betekent dat daarom ook dat alles goed werkt.\n
			\n
			Groeten,\n
			Sjoerd Hardeman\n
			\n
			Schademelding:\n
			".$rapport;
			$succes = mosMail($my->email,$my->name,$my->email,"Schademelding $boot->bname",$rapport);
		}
		//if (!$kapot) $succes = mosMail($my->email,$my->name,$email_schade,"Schademelding $boot->bname",$rapport);
		ab_HTML :: resultaat ($option,$return);
	}
	else {
		ab_HTML :: error ($option, "Er is een fout opgetereden. Neem contact op met <a href='mailto:webmaster@skoll.nl'>webmaster@skoll.nl</a><br> Foutmelding: ".$database->getErrorMsg()) ;
	}
	if ($edit && $kapot) {
		$start = $now;
		$eind = $now + 86400*7;
		$sender = array ("email" =>"materiaal@skoll.nl", name =>"De materiaalcommissaris der A.A.S.R. Skøll");
		$message = "Helaas is er aan deze boot schade ontstaan. Daarom is je afschrijving komen te vervallen. Via het online afschrijfboek kun je een andere boot afschrijven. \n
		\n
		Met vriendelijke groeten,\n
		De materiaalcommissie\n
		\n
		Schademelding: ".$schade ;
		email_func($option,$bid,$schade,$sender,$start,$eind);
	}
}

function email_func($option,$bid,$message,$sender,$start,$eind) {
	// Automatische mail een week vooruit om schades te melden.
	global $database,$local;
	setlocale(LC_TIME, $local);
	
	$query = "SELECT users.name,users.email,ab_boats.bname,UNIX_TIMESTAMP(r.start) as start FROM ab_reservations r LEFT JOIN users ON r.uid=users.id LEFT JOIN ab_boats ON r.bid=ab_boats.bid WHERE r.bid='$bid' HAVING start >= $start AND start < $eind";
	
	$database->setQuery($query);
	$results = $database->loadObjectList();

	foreach ($results as $result) {
		$mail = "Beste ".$result->name.",\n\n";
		$mail = $mail . "Je hebt op ".strftime("%A %d %B om %H:%M",$result->start)." de boot ".$result->bname." afgeschreven. Helaas is de afschrijving vervallen, omdat de boot uit te vaart gehaald is. De reden hiervoor is: \n";
		$mail = $mail . $message ; 
		$succes = mosMail($sender["email"],$sender["name"],$result->email,"Annulering afschrijving $result->bname",$mail);
	}
	return $succes;
}

function freeres_ab($option) {
	global $mainframe,$database,$my,$afschrijfbaas;
	
	if (!in_array($my->id,$afschrijfbaas)) {
		$result = "Je bent niet gerechtigd deze pagina te bekijken <br />";
		ab_HTML :: error($option,$result);
	}
	else {
		$mainframe->appendPathWay( "Vrije afschrijving");
		
		// Laad boten
		$query = "SELECT bid,bname,btype,bscull,bcoxed,bn_seats from ab_boats ORDER BY bspeciaal,bn_seats,bname";
		$database->setQuery($query);
		$boten = $database->loadObjectList();
		
		// Laad leden
		$blocklist="62";
		$query = "SELECT id,name from users where id != '$blocklist' ORDER BY name";
		$database->setQuery($query);
		$leden = $database->loadObjectList();

		ab_HTML :: freeres ($option,$boten,$leden);
	}
}


function checkfreeres($option) {
	global $database,$my,$now,$local,$afschrijfbaas,$mainframe,$time_offset;
	setlocale(LC_TIME, $local);
	$result = NULL;
	
	if (!in_array($my->id,$afschrijfbaas)) {
		$result = "Je bent niet gerechtigd deze pagina te bekijken <br />";
		ab_HTML :: error($option,$result);
		return;
	}
	$mainframe->appendPathWay( "Vrije afschrijving");
	// Inlezen data
	$bootids = mosGetParam($_POST,'bootid');
	foreach ($bootids as $bootid) {
		$fieldname = 'boot'.intval($bootid);
		$bids[intval($bootid)] = intval(mosGetParam($_POST,$fieldname));
	}
	$bids=array_unique($bids);
	$lidid = intval(mosGetParam($_POST,'lid'));
	$arr_start = explode("-",mosGetParam($_POST,'startdatum'));
	$startuur = intval(mosGetParam($_POST,'startuur'));
	$startminuut = intval(mosGetParam($_POST,'startminuut'));
	$arr_eind = NULL;
	$arr_herhaal = NULL;
	if (mosGetParam($_POST,'diffeind')) {
		$arr_eind = explode("-",mosGetParam($_POST,'einddatum'));
	}
	else {
		$arr_eind = $arr_start;
	}
               $einduur = intval(mosGetParam($_POST,'einduur'));
               $eindminuut = intval(mosGetParam($_POST,'eindminuut'));
	$start = mktime($startuur,$startminuut,0,$arr_start[1],$arr_start[0],$arr_start[2])+$time_offset*3600;
	$eind = mktime($einduur,$eindminuut,0,$arr_eind[1],$arr_eind[0],$arr_eind[2])+$time_offset*3600;
	$herhaal = $eind;
	if (mosGetParam($_POST,'herhalen')) {
		$arr_herhaal = explode("-",mosGetParam($_POST,'herhaaldatum'));
		$herhaal = mktime(23,59,59,$arr_herhaal[1],$arr_herhaal[0],$arr_herhaal[2]);
	}
	
	$runner_start = $start;
	$runner_eind = $eind;
	while ($herhaal >= $runner_eind) {
		foreach ($bids as $bid) {
			$query = "SELECT r.id AS id, u.name AS naam, u.email AS email,b.bname AS bootnaam, r.bid AS bid, UNIX_TIMESTAMP(r.start) AS start,UNIX_TIMESTAMP(r.finish) AS finish FROM ab_reservations as r LEFT JOIN users as u ON u.id=r.uid LEFT JOIN ab_boats as b ON b.bid=r.bid WHERE r.bid='$bid' HAVING start < $runner_eind AND finish > $runner_start";
			$database->setQuery($query);
			if ($database->loadResult())
				$result[] = $database->loadObjectList();
		}
		$runner_start += 86400*7;
		$runner_eind += 86400*7;
	}
	if(!count($result)) {
		$msg = makefreeres($option,$lidid,$bids,$start,$eind,$herhaal);
		ab_HTML :: resultaat($option,$msg);
	}
	else
		ab_HTML :: confirm_freeres($option,$result,$lidid,$bids,$start,$eind,$herhaal);
}

function array_intval($supposedint) {
	return intval($supposedint);
}

function forcefreeres($option) {
	global $database,$my,$now,$local,$afschrijfbaas,$mainframe;
	setlocale(LC_TIME, $local);
	$result = NULL;
	
	if (!in_array($my->id,$afschrijfbaas)) {
		$result = "Je bent niet gerechtigd deze pagina te bekijken <br />";
		ab_HTML :: error($option,$result);
		return;
	}
	$mainframe->appendPathWay( "Vrije afschrijving");
	// Inlezen data
	$bids = unserialize(stripslashes(mosGetParam($_POST,'bids')));
	$bids = array_map('array_intval',$bids);
	$bids = array_unique($bids);
	
	$ids = unserialize(stripslashes(mosGetParam($_POST,'ids')));
	$ids = array_map('array_intval',$ids);
	$ids = array_unique($ids);
	
	$lidid = intval(mosGetParam($_POST,'lidid'));
	$start = intval(mosGetParam($_POST,'start'));
	$eind = intval(mosGetParam($_POST,'eind'));
	$herhaal = intval(mosGetParam($_POST,'herhaal'));
	
	// Haal mail op
	$stuurmail = false;
	if (mosGetParam($_POST,'stuurmail')) {
		$stuurmail = true;
		$message = stripslashes(mosGetParam($_POST,'email'));
	}
	
	$database->setQuery("SELECT name FROM users WHERE id='$lidid' LIMIT 1");
	if (!$database->Query())
		echo $database->gerErrorMsg();
	$lidr = $database->loadObjectList();
	$lidnaam = $lidr[0]->name;
	

	// Verwijder overlappende reserveringen en stuur een mail
	foreach ($ids as $id) {
		// Haal reserveringsdata op
		$query = "SELECT r.uid AS uid,u.name AS naam, u.email AS email,b.bname AS bootnaam, r.bid AS bid, UNIX_TIMESTAMP(r.start) AS start FROM ab_reservations as r LEFT JOIN users as u ON u.id=r.uid LEFT JOIN ab_boats as b ON b.bid=r.bid WHERE r.id='$id'";
		$database->setQuery($query);
		if (!$database->Query())
			echo $database->getErrorMsg();
		$database->loadObject($r);
		
		if ($stuurmail) {
			// Maak en stuur mail
			$email = str_replace('{boot}',$r->bootnaam,$message);
			$email = str_replace('{datum}',strftime("%A %d %B %Y",$r->start),$email);
			$email = str_replace('{tijd}',strftime("%H:%M",$r->start),$email);
			$email = str_replace('{mijnnaam}',$my->name,$email);
			$email = str_replace('{oudreserveernaam}',$r->naam,$email);
			$email = str_replace('{nieuwreserveernaam}',$lidnaam,$email);
		
			$succes = mosMail($my->email,$my->name,$r->email,"Annulering afschrijving $result->bootnaam",$email);
		
			if(!$succes) echo "Mail zenden mislukt!";
		}
		
		$database->setQuery("DELETE FROM ab_reservations WHERE id = '$id'");
		if(!$database->Query() ) {
			$return = "Er is een fout opgetreden.Neem contact op met <a href='mailto:webmaster@skoll.nl'>webmaster@skoll.nl</a><br> Foutmelding: ".$database->getErrorMsg();
			ab_HTML :: error($option, $return);
			return;
		}
	}
	
	// En doe nu de reserveringen
	$msg = makefreeres($option,$lidid,$bids,$start,$eind,$herhaal);
	ab_HTML :: resultaat($option,$msg);
}

function makefreeres($option,$lidid,$bids,$start,$eind,$herhaal) {
	global $database,$my,$afschrijfbaas,$Itemid;
	$return = NULL;
	
	if (!in_array($my->id,$afschrijfbaas)) {
		$result = "Je bent niet gerechtigd deze pagina te bekijken <br />";
		ab_HTML :: error($option,$result);
		return;
	}
	

	while ($herhaal >= $eind) {
		foreach ($bids as $bid) {
			$query = "INSERT INTO ab_reservations VALUES(NULL,$bid, $lidid, NULL, FROM_UNIXTIME($start), FROM_UNIXTIME($eind))";
			$database->setQuery($query);
		
			if(!$database->Query() ) {
				$return = "Er is een fout opgetreden.Neem contact op met <a href='mailto:webmaster@skoll.nl'>webmaster@skoll.nl</a><br> Foutmelding: ".$database->getErrorMsg();
				ab_HTML :: error($option, $return);
				return;
			}
		}
		$start += 86400*7;
 		$eind += 86400*7;
	}
	$link = "index.php?option=$option&Itemid=$Itemid";
	$return = "De reservering(en) is(zijn) geplaatst. <a href=".sefRelToAbs( $link ).">Klik hier</a> om terug te keren naar het afschrijfboek.<br />\n";
	return $return;
}

function admin($option) {
	global $my,$afschrijfbaas,$mainframe;
	if (!in_array($my->id,$afschrijfbaas)) {
		ab_HTML :: error($option, 'Je bent niet gerechtigd deze pagina te bekijken' );
		return;
	}

	$mainframe->appendPathWay( "Administratie");
	ab_HTML :: admin($option);
}

function schadeboek($option) {
	global $my,$database,$mainframe;
	
	$datum=intval(mosGetParam($_REQUEST,'datum'));
	$type=intval(mosGetParam($_REQUEST,'type'));
	
	$mainframe->appendPathWay( "Schadeboek");
	$database->setQuery("select b.bid AS bid, b.bname AS bname, b.bn_seats AS bn_seats, b.btype AS btype, b.bscull AS bscull, b.bcoxed AS bcoxed, b.bspeciaal AS bspeciaal, s.kapot AS kapot, s.schade AS schade, s.rapport AS rapport FROM ab_boats AS b LEFT JOIN ab_schade AS s ON b.bid=s.bid ORDER BY bname");
	if(!$database->Query() ) {
		$return = "Er is een fout opgetreden.Neem contact op met <a href='mailto:webmaster@skoll.nl'>webmaster@skoll.nl</a><br> Foutmelding: ".$database->getErrorMsg();
		ab_HTML :: error($option, $return);
		return;
	}
	$bootlijst = $database->loadObjectList();
	
	ab_HTML :: schadeboek($option,$bootlijst,$type,$datum);
}

?>
